geos::index::chain::MonotoneChain Class Reference

Monotone Chains are a way of partitioning the segments of a linestring to allow for fast searching of intersections. More...

`#include <MonotoneChain.h>`

## Public Member Functions

| MonotoneChain (const geom::CoordinateSequence &pts, std::size_t start, std::size_t end, void *context)
const geom::Envelope & | getEnvelope () const
| Returned envelope is owned by this class.
const geom::Envelope & | getEnvelope (double expansionDistance) const
size_t | getStartIndex () const
size_t | getEndIndex () const
void | getLineSegment (std::size_t index, geom::LineSegment &ls) const
| Set given LineSegment with points of the segment starting at the given index.
std::unique_ptr< geom::CoordinateSequence > | getCoordinates () const
void | select (const geom::Envelope &searchEnv, MonotoneChainSelectAction &mcs) const
void | computeOverlaps (const MonotoneChain *mc, MonotoneChainOverlapAction *mco) const
void | computeOverlaps (const MonotoneChain *mc, double overlapTolerance, MonotoneChainOverlapAction *mco) const
void * | getContext () const

## Detailed Description

Monotone Chains are a way of partitioning the segments of a linestring to allow for fast searching of intersections.

They have the following properties:

- the segments within a monotone chain never intersect each other
- the envelope of any contiguous subset of the segments in a monotone chain is equal to the envelope of the endpoints of the subset.

Property 1 means that there is no need to test pairs of segments from within the same monotone chain for intersection. Property 2 allows an efficient binary search to be used to find the intersection points of two monotone chains.

For many types of real-world data, these properties eliminate a large number of segment comparisons, producing substantial speed gains.

One of the goals of this implementation of MonotoneChains is to be as space and time efficient as possible. One design choice that aids this is that a MonotoneChain is based on a subarray of a list of points. This means that new arrays of points (potentially very large) do not have to be allocated.

MonotoneChains support the following kinds of queries:

- Envelope select: determine all the segments in the chain which intersect a given envelope
- Overlap: determine all the pairs of segments in two chains whose envelopes overlap

This implementation of MonotoneChains uses the concept of internal iterators to return the resultsets for the above queries. This has time and space advantages, since it is not necessary to build lists of instantiated objects to represent the segments returned by the query. However, it does mean that the queries are not thread-safe.

## Constructor & Destructor Documentation

## MonotoneChain()

geos::index::chain::MonotoneChain::MonotoneChain | ( | const geom::CoordinateSequence & | pts,
|  | std::size_t | start,
|  | std::size_t | end,
|  | void * | context )

Parameters

  pts | Ownership left to caller, this class holds a reference.
  start |
  end |
  context | Ownership left to caller, this class holds a reference.

References MonotoneChain().

Referenced by MonotoneChain(), and select().

## Member Function Documentation

## getCoordinates()

std::unique_ptr< geom::CoordinateSequence > geos::index::chain::MonotoneChain::getCoordinates | ( |  | ) | const

Return the subsequence of coordinates forming this chain. Allocates a new CoordinateSequence to hold the Coordinates

## select()

void geos::index::chain::MonotoneChain::select | ( | const geom::Envelope & | searchEnv,
|  | MonotoneChainSelectAction & | mcs ) const

Determine all the line segments in the chain whose envelopes overlap the searchEnvelope, and process them

References MonotoneChain().

The documentation for this class was generated from the following file:

- index/chain/MonotoneChain.h